// -------------------------------------------------------------
// HLSL
// 
// Copyright (c) 2002,2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// 
// -------------------------------------------------------------
float4x4 mWVP;        // -> ǥȯ

// -------------------------------------------------------------
// ؽó
// -------------------------------------------------------------
texture Tex;
sampler Samp = sampler_state
{
    Texture = <Tex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

// -------------------------------------------------------------
// ̴ ȼ̴ ѱ 
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos        : POSITION;
    float2 Tex        : TEXCOORD0;
};

// -------------------------------------------------------------
// ̴
// -------------------------------------------------------------
VS_OUTPUT VS (
      float4 Pos    : POSITION            // ǥ
    , float2 Tex    : TEXCOORD            // ؽóǥ
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // µ
    
    Out.Pos = mul( Pos, mWVP );            // ġȯ
    
    Out.Tex = Tex;                        // ؽóǥ
    
    return Out;
}
// -------------------------------------------------------------
// ȼ̴
// -------------------------------------------------------------
float4 PS ( VS_OUTPUT In ) : COLOR
{
    return tex2D( Samp, In.Tex );
}

// -------------------------------------------------------------
// ũ
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // ̴
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_1_1 PS();
    }
}
