//-------------------------------------------------------------
// File: main.h
//
// Desc: HLSL
//-------------------------------------------------------------
#pragma once




//-------------------------------------------------------------
//  & 
//-------------------------------------------------------------
// Էµ͸  ü
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZ;
    BOOL bX;
    BOOL bA;
    BOOL bS;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: ø̼ Ŭ
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	LPD3DXEFFECT					m_pEffect;	// ̴
	D3DXHANDLE						m_hTechnique;// ũ
	D3DXHANDLE						m_hmWVP;	// ~
	LPDIRECT3DVERTEXDECLARATION9	m_pDecl;	// 

	CD3DMesh						*m_pMesh;	// 

	D3DXMATRIX						m_mWorld;	//  
	D3DXMATRIX						m_mView;	//  
	D3DXMATRIX						m_mProj;	//  

    FLOAT						m_fWorldRotX;	// Xȸ
    FLOAT						m_fWorldRotY;	// Yȸ

	BOOL						m_bLoadingApp;	// ε?
    CD3DFont*					m_pFont;		// ư
    UserInput					m_UserInput;	// Էµ
	
protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice(D3DCAPS9*, DWORD, D3DFORMAT);

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg
					, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};
