#include <d3d9.h>                            // Direct X 

// 
LPDIRECT3D9              g_pD3D    = NULL;   // Direct 3D 
LPDIRECT3DDEVICE9        g_pD3DDev = NULL;   // ī忡 


//-----------------------------------------------------------------------------
// Direct X Graphics ʱȭ
//-----------------------------------------------------------------------------
HRESULT InitD3D( HWND hWnd )
{
    // Direct 3D 
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ))) return E_FAIL;

    // ÷  
    D3DDISPLAYMODE d3ddm;
    if( FAILED( g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm )))
        return E_FAIL;

    // Direct 3D ̽ 
    D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );        //  0
    d3dpp.Windowed = TRUE;                      // 
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;   // ȭȯ 
    d3dpp.BackBufferFormat = d3ddm.Format;      //  ȭ  

    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &g_pD3DDev ) ) ) return E_FAIL;

    return S_OK;
}
//-----------------------------------------------------------------------------
// Լ
//-----------------------------------------------------------------------------
VOID Render()
{
    //  ˰ĥѴ
    g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );
    
    g_pD3DDev->BeginScene(); //  
    
    // ߰  ̰
    
    g_pD3DDev->EndScene(); //  
    
    //    쿡 Ÿ Ѵ
    g_pD3DDev->Present( NULL, NULL, NULL, NULL );
}
//-----------------------------------------------------------------------------		
// 	
//-----------------------------------------------------------------------------		
#define SAFE_RELEASE(p) if(p){(p)->Release();(p)=NULL;}		
		
VOID Cleanup()
{		
    SAFE_RELEASE(g_pD3DDev);		
    SAFE_RELEASE(g_pD3D);		
}	
