//-------------------------------------------------------------
// File: main.h
//
// Desc: Ŀ 
//-------------------------------------------------------------
#pragma once



//-------------------------------------------------------------
//  & 
//-------------------------------------------------------------
// Էµ͸  ü
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: ø̼ Ŭ
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	// ̴
	LPD3DXEFFECT		    m_pEffect;		// Ʈ
	D3DXHANDLE				m_hTechnique;	// ũ
	D3DXHANDLE				m_hafWeight;	// ġ迭
	D3DXHANDLE				m_htSrcTex;		// ؽó
	D3DXHANDLE				m_htBlurTex;	// ؽó
	D3DXHANDLE				m_htBlendTex;	// ؽó

	//  Ÿ
	LPDIRECT3DSURFACE9		m_pMapZ;		// ̹
	LPDIRECT3DTEXTURE9		m_pOriginalTex;	// ؽó
	LPDIRECT3DSURFACE9		m_pOriginalSurf;// ǥ
	LPDIRECT3DTEXTURE9		m_pPostTex[2];	// ؽó
	LPDIRECT3DSURFACE9		m_pPostSurf[2];	// ǥ

	// ޽
	CD3DMesh				*m_pMesh;
	CD3DMesh				*m_pMeshBg;
	LPDIRECT3DTEXTURE9		m_pTex;
			
	// ȯ
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;

	BOOL					m_bLoadingApp;	// ε?
    CD3DFont*				m_pFont;		// Ʈ
    UserInput				m_UserInput;	// Էµ

    FLOAT                   m_fWorldRotX;   // Xȸ
    FLOAT                   m_fWorldRotY;   // Yȸ
    FLOAT                   m_fViewZoom;    // Ÿ

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

