//-------------------------------------------------------------
// File: main.h
//
// Desc: ũ 
//-------------------------------------------------------------
#pragma once



//-------------------------------------------------------------
//  & 
//-------------------------------------------------------------
// Էµ͸  ü
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
	BOOL bSizeUp;
	BOOL bSizeDown;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: ø̼ Ŭ
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	CD3DMesh				*m_pMesh;
	CD3DMesh				*m_pMeshBg;
	FLOAT					m_size;			// ڂ
			
	// ̴
	LPD3DXEFFECT		    m_pEffect;		// Ʈ
	D3DXHANDLE				m_hTechnique;	// ũ
	D3DXHANDLE				m_htSrcMap;		// ؽó
	D3DXHANDLE				m_htWeightMap;	// ġ Ÿ ؽó

	// Ÿ
	LPDIRECT3DSURFACE9		m_pMapZ;		// ̹
	LPDIRECT3DTEXTURE9		m_pSatTex;		// SATؽó
	LPDIRECT3DSURFACE9		m_pSatSurf;		// SATǥ
	LPDIRECT3DTEXTURE9		m_pWeightTex;	// ġؽó

	// ȯ
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;

	BOOL					m_bLoadingApp;	// ε?
    CD3DFont*				m_pFont;		// Ʈ
    UserInput				m_UserInput;	// Էµ

    FLOAT                   m_fWorldRotX;   // Xȸ
    FLOAT                   m_fWorldRotY;   // Yȸ
    FLOAT                   m_fViewZoom;    // Ÿ

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
	void    UpdateParam();
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

